VTK: vtkDataSet Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkDataSet Class Referenceabstract

abstract class to specify dataset behavior More...

`#include <vtkDataSet.h>`

Inheritance diagram for vtkDataSet:
[legend]
Collaboration diagram for vtkDataSet:
[legend]

## Public Types
enum | FieldDataType { DATA_OBJECT_FIELD = 0 , POINT_DATA_FIELD = 1 , CELL_DATA_FIELD = 2 }
typedef vtkDataObject | Superclass
Public Types inherited from vtkDataObject
enum | FieldAssociations { FIELD_ASSOCIATION_POINTS , FIELD_ASSOCIATION_CELLS , FIELD_ASSOCIATION_NONE , FIELD_ASSOCIATION_POINTS_THEN_CELLS , FIELD_ASSOCIATION_VERTICES , FIELD_ASSOCIATION_EDGES , FIELD_ASSOCIATION_ROWS , NUMBER_OF_ASSOCIATIONS }
| Possible values for the FIELD_ASSOCIATION information entry. More...
enum | AttributeTypes { POINT , CELL , FIELD , POINT_THEN_CELL , VERTEX , EDGE , ROW , NUMBER_OF_ATTRIBUTE_TYPES }
| Possible attribute types. More...
enum | FieldOperations { FIELD_OPERATION_PRESERVED , FIELD_OPERATION_REINTERPOLATED , FIELD_OPERATION_MODIFIED , FIELD_OPERATION_REMOVED }
| Possible values for the FIELD_OPERATION information entry. More...
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkDataSet * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | CopyStructure (vtkDataSet *ds)=0
| Copy the geometric and topological structure of an object. More...
virtual void | CopyAttributes (vtkDataSet *ds)
| Copy the attributes associated with the specified dataset to this instance of vtkDataSet. More...
virtual vtkIdType | GetNumberOfPoints ()=0
| Determine the number of points composing the dataset. More...
virtual vtkIdType | GetNumberOfCells ()=0
| Determine the number of cells composing the dataset. More...
virtual double * | GetPoint (vtkIdType ptId)=0
| Get point coordinates with ptId such that: 0 <= ptId < NumberOfPoints. More...
virtual void | GetPoint (vtkIdType id, double x[3])
| Copy point coordinates into user provided array x[3] for specified point id. More...
virtual vtkCellIterator * | NewCellIterator ()
| Return an iterator that traverses the cells in this data set. More...
virtual vtkCell * | GetCell (vtkIdType cellId)=0
| Get cell with cellId such that: 0 <= cellId < NumberOfCells. More...
virtual vtkCell * | GetCell (int vtkNotUsed(i), int vtkNotUsed(j), int vtkNotUsed(k))
void | SetCellOrderAndRationalWeights (vtkIdType cellId, vtkGenericCell *cell)
virtual void | GetCell (vtkIdType cellId, vtkGenericCell *cell)=0
| Get cell with cellId such that: 0 <= cellId < NumberOfCells. More...
virtual void | GetCellBounds (vtkIdType cellId, double bounds[6])
| Get the bounds of the cell with cellId such that: 0 <= cellId < NumberOfCells. More...
virtual int | GetCellType (vtkIdType cellId)=0
| Get type of cell with cellId such that: 0 <= cellId < NumberOfCells. More...
virtual vtkIdType | GetCellSize (vtkIdType cellId)
| Get the size of cell with cellId such that: 0 <= cellId < NumberOfCells. More...
virtual void | GetCellTypes (vtkCellTypes *types)
| Get a list of types of cells in a dataset. More...
virtual void | GetCellPoints (vtkIdType cellId, vtkIdList *ptIds)=0
| Topological inquiry to get points defining cell. More...
virtual void | GetCellPoints (vtkIdType cellId, vtkIdType &npts, vtkIdType const *&pts, vtkIdList *ptIds)
| Topological inquiry to get points defining cell. More...
virtual void | GetPointCells (vtkIdType ptId, vtkIdList *cellIds)=0
| Topological inquiry to get cells using point. More...
virtual void | GetCellNeighbors (vtkIdType cellId, vtkIdList *ptIds, vtkIdList *cellIds)
| Topological inquiry to get all cells using list of points exclusive of cell specified (e.g., cellId). More...
int | GetCellNumberOfFaces (vtkIdType cellId, unsigned char &cellType, vtkGenericCell *cell)
| Get the number of faces of a cell. More...
virtual vtkIdType | FindCell (double x[3], vtkCell *cell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights)=0
| Locate cell based on global coordinate x and tolerance squared. More...
virtual vtkIdType | FindCell (double x[3], vtkCell *cell, vtkGenericCell *gencell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights)=0
| This is a version of the above method that can be used with multithreaded applications. More...
virtual vtkCell * | FindAndGetCell (double x[3], vtkCell *cell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights)
| Locate the cell that contains a point and return the cell. More...
vtkMTimeType | GetMTime () override
| Datasets are composite objects and need to check each part for MTime THIS METHOD IS THREAD SAFE. More...
vtkCellData * | GetCellData ()
| Return a pointer to this dataset's cell data. More...
vtkPointData * | GetPointData ()
| Return a pointer to this dataset's point data. More...
virtual void | Squeeze ()
| Reclaim any extra memory used to store data. More...
virtual void | ComputeBounds ()
| Compute the data bounding box from data points. More...
double * | GetBounds ()
| Return a pointer to the geometry bounding box in the form (xmin,xmax, ymin,ymax, zmin,zmax). More...
void | GetBounds (double bounds[6])
| Return a pointer to the geometry bounding box in the form (xmin,xmax, ymin,ymax, zmin,zmax). More...
double * | GetCenter ()
| Get the center of the bounding box. More...
void | GetCenter (double center[3])
| Get the center of the bounding box. More...
double | GetLength ()
| Return the length of the diagonal of the bounding box. More...
double | GetLength2 ()
| Return the squared length of the diagonal of the bounding box. More...
void | Initialize () override
| Restore data object to initial state. More...
virtual void | GetScalarRange (double range[2])
| Convenience method to get the range of the first component (and only the first component) of any scalars in the data set. More...
double * | GetScalarRange ()
| Convenience method to get the range of the first component (and only the first component) of any scalars in the data set. More...
virtual int | GetMaxCellSize ()=0
| Convenience method returns largest cell size in dataset. More...
unsigned long | GetActualMemorySize () override
| Return the actual size of the data in kibibytes (1024 bytes). More...
int | GetDataObjectType () override
| Return the type of data object. More...
int | CheckAttributes ()
| This method checks to see if the cell and point attributes match the geometry. More...
vtkFieldData * | GetAttributesAsFieldData (int type) override
| Returns the attributes of the data object as a vtkFieldData. More...
vtkIdType | GetNumberOfElements (int type) override
| Get the number of elements for a specific attribute type (POINT, CELL, etc.). More...
bool | HasAnyGhostCells ()
| Returns 1 if there are any ghost cells 0 otherwise. More...
bool | HasAnyGhostPoints ()
| Returns 1 if there are any ghost points 0 otherwise. More...
virtual bool | HasAnyBlankCells ()
| Returns 1 if there are any blanking cells 0 otherwise. More...
virtual bool | HasAnyBlankPoints ()
| Returns 1 if there are any blanking points 0 otherwise. More...
vtkUnsignedCharArray * | GetPointGhostArray ()
| Gets the array that defines the ghost type of each point. More...
void | UpdatePointGhostArrayCache ()
| Updates the pointer to the point ghost array. More...
vtkUnsignedCharArray * | AllocatePointGhostArray ()
| Allocate ghost array for points. More...
vtkUnsignedCharArray * | GetCellGhostArray ()
| Get the array that defines the ghost type of each cell. More...
void | UpdateCellGhostArrayCache ()
| Updates the pointer to the cell ghost array. More...
vtkUnsignedCharArray * | AllocateCellGhostArray ()
| Allocate ghost array for cells. More...
vtkUnsignedCharArray * | GetGhostArray (int type) override
| Returns the ghost array for the given type (point or cell). More...
vtkIdType | FindPoint (double x, double y, double z)
| Locate the closest point to the global coordinate x. More...
virtual vtkIdType | FindPoint (double x[3])=0
| Locate the closest point to the global coordinate x. More...
void | ShallowCopy (vtkDataObject *src) override
| Shallow and Deep copy. More...
void | DeepCopy (vtkDataObject *src) override
| Shallow and Deep copy. More...
virtual void | GenerateGhostArray (int zeroExt[6])
| Normally called by pipeline executives or algorithms only. More...
virtual void | GenerateGhostArray (int zeroExt[6], bool cellOnly)
| Normally called by pipeline executives or algorithms only. More...
Public Member Functions inherited from vtkDataObject
vtkDataObject * | NewInstance () const
void | ReleaseData ()
| Release data back to system to conserve memory resource. More...
vtkMTimeType | GetUpdateTime ()
| Used by Threaded ports to determine if they should initiate an asynchronous update (still in development). More...
virtual void | CopyInformationFromPipeline (vtkInformation *vtkNotUsed(info))
| Copy from the pipeline information to the data object's own information. More...
virtual void | CopyInformationToPipeline (vtkInformation *vtkNotUsed(info))
| Copy information from this data object to the pipeline information. More...
void | DataHasBeenGenerated ()
| This method is called by the source when it executes to generate data. More...
virtual void | PrepareForNewData ()
| make the output data ready for new data to be inserted. More...
virtual int | GetExtentType ()
| The ExtentType will be left as VTK_PIECES_EXTENT for data objects such as vtkPolyData and vtkUnstructuredGrid. More...
virtual void | Crop (const int *updateExtent)
| This method crops the data object (if necessary) so that the extent matches the update extent. More...
virtual vtkDataSetAttributes * | GetAttributes (int type)
| Returns the attributes of the data object of the specified attribute type. More...
virtual int | GetAttributeTypeForArray (vtkAbstractArray *arr)
| Retrieves the attribute type that an array came from. More...
virtual vtkInformation * | GetInformation ()
| Set/Get the information object associated with this data object. More...
virtual void | SetInformation (vtkInformation *)
| Set/Get the information object associated with this data object. More...
virtual vtkTypeBool | GetDataReleased ()
| Get the flag indicating the data has been released. More...
virtual void | SetFieldData (vtkFieldData *)
| Assign or retrieve a general field data to this data object. More...
virtual vtkFieldData * | GetFieldData ()
| Assign or retrieve a general field data to this data object. More...
void | GlobalReleaseDataFlagOn ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
void | GlobalReleaseDataFlagOff ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDataSet * | SafeDownCast (vtkObjectBase *o)
static vtkDataSet * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkDataSet * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
Static Public Member Functions inherited from vtkDataObject
static vtkDataObject * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDataObject * | SafeDownCast (vtkObjectBase *o)
static vtkInformation * | GetActiveFieldInformation (vtkInformation *info, int fieldAssociation, int attributeType)
| Return the information object within the input information object's field data corresponding to the specified association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS) and attribute (SCALARS, VECTORS, NORMALS, TCOORDS, or TENSORS) More...
static vtkInformation * | GetNamedFieldInformation (vtkInformation *info, int fieldAssociation, const char *name)
| Return the information object within the input information object's field data corresponding to the specified association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS) and name. More...
static void | RemoveNamedFieldInformation (vtkInformation *info, int fieldAssociation, const char *name)
| Remove the info associated with an array. More...
static vtkInformation * | SetActiveAttribute (vtkInformation *info, int fieldAssociation, const char *attributeName, int attributeType)
| Set the named array to be the active field for the specified type (SCALARS, VECTORS, NORMALS, TCOORDS, or TENSORS) and association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS). More...
static void | SetActiveAttributeInfo (vtkInformation *info, int fieldAssociation, int attributeType, const char *name, int arrayType, int numComponents, int numTuples)
| Set the name, array type, number of components, and number of tuples within the passed information object for the active attribute of type attributeType (in specified association, FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS). More...
static void | SetPointDataActiveScalarInfo (vtkInformation *info, int arrayType, int numComponents)
| Convenience version of previous method for use (primarily) by the Imaging filters. More...
static const char * | GetAssociationTypeAsString (int associationType)
| Given an integer association type, this static method returns a string type for the attribute (i.e. More...
static int | GetAssociationTypeFromString (const char *associationName)
| Given a string association name, this static method returns an integer association type for the attribute (i.e. More...
static vtkInformationStringKey * | DATA_TYPE_NAME ()
static vtkInformationDataObjectKey * | DATA_OBJECT ()
static vtkInformationIntegerKey * | DATA_EXTENT_TYPE ()
static vtkInformationIntegerPointerKey * | DATA_EXTENT ()
static vtkInformationIntegerVectorKey * | ALL_PIECES_EXTENT ()
static vtkInformationIntegerKey * | DATA_PIECE_NUMBER ()
static vtkInformationIntegerKey * | DATA_NUMBER_OF_PIECES ()
static vtkInformationIntegerKey * | DATA_NUMBER_OF_GHOST_LEVELS ()
static vtkInformationDoubleKey * | DATA_TIME_STEP ()
static vtkInformationInformationVectorKey * | POINT_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | CELL_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | VERTEX_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | EDGE_DATA_VECTOR ()
static vtkInformationIntegerKey * | FIELD_ARRAY_TYPE ()
static vtkInformationIntegerKey * | FIELD_ASSOCIATION ()
static vtkInformationIntegerKey * | FIELD_ATTRIBUTE_TYPE ()
static vtkInformationIntegerKey * | FIELD_ACTIVE_ATTRIBUTE ()
static vtkInformationIntegerKey * | FIELD_NUMBER_OF_COMPONENTS ()
static vtkInformationIntegerKey * | FIELD_NUMBER_OF_TUPLES ()
static vtkInformationIntegerKey * | FIELD_OPERATION ()
static vtkInformationDoubleVectorKey * | FIELD_RANGE ()
static vtkInformationIntegerVectorKey * | PIECE_EXTENT ()
static vtkInformationStringKey * | FIELD_NAME ()
static vtkInformationDoubleVectorKey * | ORIGIN ()
static vtkInformationDoubleVectorKey * | SPACING ()
static vtkInformationDoubleVectorKey * | DIRECTION ()
static vtkInformationDoubleVectorKey * | BOUNDING_BOX ()
static vtkInformationDataObjectKey * | SIL ()
static vtkDataObject * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkDataObject * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
static void | SetGlobalReleaseDataFlag (vtkTypeBool val)
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
static vtkTypeBool | GetGlobalReleaseDataFlag ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkDataSet ()
| ~vtkDataSet () override
virtual void | ComputeScalarRange ()
| Compute the range of the scalars and cache it into ScalarRange only if the cache became invalid (ScalarRangeComputeTime). More...
Protected Member Functions inherited from vtkDataObject
| vtkDataObject ()
| ~vtkDataObject () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkCellData * | CellData
vtkPointData * | PointData
vtkCallbackCommand * | DataObserver
vtkTimeStamp | ComputeTime
double | Bounds [6]
double | Center [3]
double | ScalarRange [2]
vtkTimeStamp | ScalarRangeComputeTime
vtkUnsignedCharArray * | PointGhostArray
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
vtkUnsignedCharArray * | CellGhostArray
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
bool | PointGhostArrayCached
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
bool | CellGhostArrayCached
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
Protected Attributes inherited from vtkDataObject
vtkFieldData * | FieldData
vtkTypeBool | DataReleased
vtkTimeStamp | UpdateTime
vtkInformation * | Information
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

abstract class to specify dataset behavior

vtkDataSet is an abstract class that specifies an interface for dataset objects. vtkDataSet also provides methods to provide information about the data, such as center, bounding box, and representative length.

In vtk a dataset consists of a structure (geometry and topology) and attribute data. The structure is defined implicitly or explicitly as a collection of cells. The geometry of the structure is contained in point coordinates plus the cell interpolation functions. The topology of the dataset structure is defined by cell types and how the cells share their defining points.

Attribute data in vtk is either point data (data at points) or cell data (data at cells). Typically filters operate on point data, but some may operate on cell data, both cell and point data, either one, or none.

See also
  vtkPointSet vtkStructuredPoints vtkStructuredGrid vtkUnstructuredGrid vtkRectilinearGrid vtkPolyData vtkPointData vtkCellData vtkDataObject vtkFieldData

Examples:
  vtkDataSet (Examples)

Online Examples:

Tests:
  vtkDataSet (Tests)

Definition at line 61 of file vtkDataSet.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkDataObject vtkDataSet::Superclass

Definition at line 64 of file vtkDataSet.h.

## Member Enumeration Documentation

## ◆ FieldDataType

enum vtkDataSet::FieldDataType

Enumerator
DATA_OBJECT_FIELD |
POINT_DATA_FIELD |
CELL_DATA_FIELD |

Definition at line 419 of file vtkDataSet.h.

## Constructor & Destructor Documentation

## ◆ vtkDataSet()

vtkDataSet::vtkDataSet | ( |  | ) |
| protected

## ◆ ~vtkDataSet()

vtkDataSet::~vtkDataSet | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ IsTypeOf()

static vtkTypeBool vtkDataSet::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkDataSet::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkDataObject.

Reimplemented in vtkLabelHierarchy, vtkUnstructuredGrid, vtkUniformGrid, vtkStructuredPoints, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkPointSet, vtkPath, vtkImageData, vtkExplicitStructuredGrid, and vtkmDataSet.

## ◆ SafeDownCast()

static vtkDataSet* vtkDataSet::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkDataSet::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkDataObject.

Reimplemented in vtkLabelHierarchy, vtkUnstructuredGrid, vtkUniformGrid, vtkStructuredPoints, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkPointSet, vtkPath, vtkImageData, vtkExplicitStructuredGrid, and vtkmDataSet.

## ◆ NewInstance()

vtkDataSet* vtkDataSet::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkDataSet::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkDataObject.

Reimplemented in vtkLabelHierarchy, vtkUnstructuredGridBase, vtkUnstructuredGrid, vtkUniformGrid, vtkStructuredPoints, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkPointSet, vtkPath, vtkMappedUnstructuredGrid< Implementation, CellIterator >, vtkImageData, and vtkExplicitStructuredGrid.

## ◆ CopyStructure()

virtual void vtkDataSet::CopyStructure | ( | vtkDataSet * | ds | ) |
| pure virtual

Copy the geometric and topological structure of an object.

Note that the invoking object and the object pointed to by the parameter ds must be of the same type. THIS METHOD IS NOT THREAD SAFE.

Implemented in vtkPointSet, vtkMappedUnstructuredGrid< Implementation, CellIterator >, vtkUnstructuredGrid, vtkUniformGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkImageData, vtkExplicitStructuredGrid, and vtkmDataSet.

## ◆ CopyAttributes()

virtual void vtkDataSet::CopyAttributes | ( | vtkDataSet * | ds | ) |
| virtual

Copy the attributes associated with the specified dataset to this instance of vtkDataSet.

THIS METHOD IS NOT THREAD SAFE.

## ◆ GetNumberOfPoints()

virtual vtkIdType vtkDataSet::GetNumberOfPoints | ( |  | ) |
| pure virtual

Determine the number of points composing the dataset.

THIS METHOD IS THREAD SAFE

Implemented in vtkStructuredGrid, vtkRectilinearGrid, vtkPointSet, vtkImageData, and vtkmDataSet.

## ◆ GetNumberOfCells()

virtual vtkIdType vtkDataSet::GetNumberOfCells | ( |  | ) |
| pure virtual

Determine the number of cells composing the dataset.

THIS METHOD IS THREAD SAFE

Implemented in vtkLabelHierarchy, vtkUnstructuredGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkPointSet, vtkPath, vtkMappedUnstructuredGrid< Implementation, CellIterator >, vtkImageData, vtkExplicitStructuredGrid, and vtkmDataSet.

## ◆ GetPoint() [1/2]

virtual double* vtkDataSet::GetPoint | ( | vtkIdType | ptId | ) |
| pure virtual

Get point coordinates with ptId such that: 0 <= ptId < NumberOfPoints.

THIS METHOD IS NOT THREAD SAFE.

Implemented in vtkStructuredGrid, vtkRectilinearGrid, vtkPointSet, vtkImageData, and vtkmDataSet.

## ◆ GetPoint() [2/2]

void vtkDataSet::GetPoint | ( | vtkIdType | id,
|  | double | x[3]
| ) |  |
| inlinevirtual

Copy point coordinates into user provided array x[3] for specified point id.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Reimplemented in vtkPointSet, vtkStructuredGrid, vtkRectilinearGrid, vtkImageData, and vtkmDataSet.

Definition at line 582 of file vtkDataSet.h.

## ◆ NewCellIterator()

virtual vtkCellIterator* vtkDataSet::NewCellIterator | ( |  | ) |
| virtual

Return an iterator that traverses the cells in this data set.

Reimplemented in vtkUnstructuredGrid, vtkPointSet, and vtkMappedUnstructuredGrid< Implementation, CellIterator >.

## ◆ GetCell() [1/3]

virtual vtkCell* vtkDataSet::GetCell | ( | vtkIdType | cellId | ) |
| pure virtual

Get cell with cellId such that: 0 <= cellId < NumberOfCells.

The returned vtkCell is an object owned by this instance, hence the return value must not be deleted by the caller.

Warning
  Repeat calls to this function for different face ids will change the data stored in the internal member object whose pointer is returned by this function.
  THIS METHOD IS NOT THREAD SAFE. For a thread-safe version, please use void GetCell(vtkIdType cellId, vtkGenericCell* cell).

Implemented in vtkLabelHierarchy, vtkPointSet, vtkPath, vtkUnstructuredGrid, vtkUniformGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkMappedUnstructuredGrid< Implementation, CellIterator >, vtkImageData, vtkExplicitStructuredGrid, and vtkmDataSet.

## ◆ GetCell() [2/3]

virtual vtkCell* vtkDataSet::GetCell | ( | int | vtkNotUsedi,
|  | int | vtkNotUsedj,
|  | int | vtkNotUsedk
| ) |  |
| inlinevirtual

Definition at line 127 of file vtkDataSet.h.

## ◆ SetCellOrderAndRationalWeights()

void vtkDataSet::SetCellOrderAndRationalWeights | ( | vtkIdType | cellId,
|  | vtkGenericCell * | cell
| ) |  |

## ◆ GetCell() [3/3]

virtual void vtkDataSet::GetCell | ( | vtkIdType | cellId,
|  | vtkGenericCell * | cell
| ) |  |
| pure virtual

Get cell with cellId such that: 0 <= cellId < NumberOfCells.

This is a thread-safe alternative to the previous GetCell() method. THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Implemented in vtkPointSet, vtkLabelHierarchy, vtkPath, vtkUnstructuredGrid, vtkUniformGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkMappedUnstructuredGrid< Implementation, CellIterator >, vtkImageData, vtkExplicitStructuredGrid, and vtkmDataSet.

## ◆ GetCellBounds()

virtual void vtkDataSet::GetCellBounds | ( | vtkIdType | cellId,
|  | double | bounds[6]
| ) |  |
| virtual

Get the bounds of the cell with cellId such that: 0 <= cellId < NumberOfCells.

A subclass may be able to determine the bounds of cell without using an expensive GetCell() method. A default implementation is provided that actually uses a GetCell() call. This is to ensure the method is available to all datasets. Subclasses should override this method to provide an efficient implementation. THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Reimplemented in vtkUnstructuredGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkImageData, vtkExplicitStructuredGrid, and vtkmDataSet.

## ◆ GetCellType()

virtual int vtkDataSet::GetCellType | ( | vtkIdType | cellId | ) |
| pure virtual

Get type of cell with cellId such that: 0 <= cellId < NumberOfCells.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Implemented in vtkLabelHierarchy, vtkPointSet, vtkPath, vtkUnstructuredGrid, vtkUniformGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkMappedUnstructuredGrid< Implementation, CellIterator >, vtkImageData, vtkExplicitStructuredGrid, and vtkmDataSet.

## ◆ GetCellSize()

virtual vtkIdType vtkDataSet::GetCellSize | ( | vtkIdType | cellId | ) |
| virtual

Get the size of cell with cellId such that: 0 <= cellId < NumberOfCells.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Warning
  This method MUST be overridden for performance reasons. Default implementation is very unefficient.

Reimplemented in vtkPointSet, vtkUnstructuredGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkImageData, and vtkExplicitStructuredGrid.

## ◆ GetCellTypes()

virtual void vtkDataSet::GetCellTypes | ( | vtkCellTypes * | types | ) |
| virtual

Get a list of types of cells in a dataset.

The list consists of an array of types (not necessarily in any order), with a single entry per type. For example a dataset 5 triangles, 3 lines, and 100 hexahedra would result a list of three entries, corresponding to the types VTK_TRIANGLE, VTK_LINE, and VTK_HEXAHEDRON. THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Reimplemented in vtkUnstructuredGrid.

## ◆ GetCellPoints() [1/2]

virtual void vtkDataSet::GetCellPoints | ( | vtkIdType | cellId,
|  | vtkIdList * | ptIds
| ) |  |
| pure virtual

Topological inquiry to get points defining cell.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Implemented in vtkPath, vtkPointSet, vtkLabelHierarchy, vtkUnstructuredGrid, vtkUniformGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkMappedUnstructuredGrid< Implementation, CellIterator >, vtkImageData, vtkExplicitStructuredGrid, and vtkmDataSet.

## ◆ GetCellPoints() [2/2]

virtual void vtkDataSet::GetCellPoints | ( | vtkIdType | cellId,
|  | vtkIdType & | npts,
|  | vtkIdType const *& | pts,
|  | vtkIdList * | ptIds
| ) |  |
| virtual

Topological inquiry to get points defining cell.

This function MAY use ptIds, which is an object that is created by each thread, to guarantee thread safety.

Warning
  Subsequent calls to this method may invalidate previous call results.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Reimplemented in vtkUnstructuredGrid, vtkPolyData, and vtkExplicitStructuredGrid.

## ◆ GetPointCells()

virtual void vtkDataSet::GetPointCells | ( | vtkIdType | ptId,
|  | vtkIdList * | cellIds
| ) |  |
| pure virtual

Topological inquiry to get cells using point.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Implemented in vtkPointSet, vtkLabelHierarchy, vtkUnstructuredGrid, vtkUniformGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkPath, vtkMappedUnstructuredGrid< Implementation, CellIterator >, vtkImageData, vtkExplicitStructuredGrid, and vtkmDataSet.

## ◆ GetCellNeighbors()

virtual void vtkDataSet::GetCellNeighbors | ( | vtkIdType | cellId,
|  | vtkIdList * | ptIds,
|  | vtkIdList * | cellIds
| ) |  |
| virtual

Topological inquiry to get all cells using list of points exclusive of cell specified (e.g., cellId).

Note that the list consists of only cells that use ALL the points provided. THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Reimplemented in vtkUnstructuredGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkImageData, and vtkExplicitStructuredGrid.

## ◆ GetCellNumberOfFaces()

int vtkDataSet::GetCellNumberOfFaces | ( | vtkIdType | cellId,
|  | unsigned char & | cellType,
|  | vtkGenericCell * | cell
| ) |  |

Get the number of faces of a cell.

Most of the times extracting the number of faces requires only extracting the cell type. However, for some cell types, the number of faces is not constant. For example, a vtkPolyhedron cell can have a different number of faces for each cell. That's why this method requires the cell id and the dataset.

## ◆ FindPoint() [1/2]

vtkIdType vtkDataSet::FindPoint | ( | double | x,
|  | double | y,
|  | double | z
| ) |  |
| inline

Locate the closest point to the global coordinate x.

Return the point id. If point id < 0; then no point found. (This may arise when point is outside of dataset.) THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Definition at line 242 of file vtkDataSet.h.

## ◆ FindPoint() [2/2]

virtual vtkIdType vtkDataSet::FindPoint | ( | double | x[3] | ) |
| pure virtual

Locate the closest point to the global coordinate x.

Return the point id. If point id < 0; then no point found. (This may arise when point is outside of dataset.) THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Implemented in vtkRectilinearGrid, vtkPointSet, vtkImageData, and vtkmDataSet.

## ◆ FindCell() [1/2]

virtual vtkIdType vtkDataSet::FindCell | ( | double | x[3],
|  | vtkCell * | cell,
|  | vtkIdType | cellId,
|  | double | tol2,
|  | int & | subId,
|  | double | pcoords[3],
|  | double * | weights
| ) |  |
| pure virtual

Locate cell based on global coordinate x and tolerance squared.

If cell and cellId is non-nullptr, then search starts from this cell and looks at immediate neighbors. Returns cellId >= 0 if inside, < 0 otherwise. The parametric coordinates are provided in pcoords[3]. The interpolation weights are returned in weights[]. (The number of weights is equal to the number of points in the found cell). Tolerance is used to control how close the point is to be considered "in" the cell. THIS METHOD IS NOT THREAD SAFE.

Implemented in vtkUniformGrid, vtkRectilinearGrid, vtkPointSet, vtkImageData, and vtkmDataSet.

## ◆ FindCell() [2/2]

virtual vtkIdType vtkDataSet::FindCell | ( | double | x[3],
|  | vtkCell * | cell,
|  | vtkGenericCell * | gencell,
|  | vtkIdType | cellId,
|  | double | tol2,
|  | int & | subId,
|  | double | pcoords[3],
|  | double * | weights
| ) |  |
| pure virtual

This is a version of the above method that can be used with multithreaded applications.

A vtkGenericCell must be passed in to be used in internal calls that might be made to GetCell() THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Implemented in vtkUniformGrid, vtkRectilinearGrid, vtkPointSet, vtkImageData, and vtkmDataSet.

## ◆ FindAndGetCell()

virtual vtkCell* vtkDataSet::FindAndGetCell | ( | double | x[3],
|  | vtkCell * | cell,
|  | vtkIdType | cellId,
|  | double | tol2,
|  | int & | subId,
|  | double | pcoords[3],
|  | double * | weights
| ) |  |
| virtual

Locate the cell that contains a point and return the cell.

Also returns the subcell id, parametric coordinates and weights for subsequent interpolation. This method combines the derived class methods int FindCell and vtkCell *GetCell. Derived classes may provide a more efficient implementation. See for example vtkStructuredPoints. THIS METHOD IS NOT THREAD SAFE.

Reimplemented in vtkUniformGrid, vtkRectilinearGrid, and vtkImageData.

## ◆ GetMTime()

vtkMTimeType vtkDataSet::GetMTime | ( |  | ) |
| overridevirtual

Datasets are composite objects and need to check each part for MTime THIS METHOD IS THREAD SAFE.

Reimplemented from vtkDataObject.

Reimplemented in vtkPolyData, vtkPointSet, and vtkMappedUnstructuredGrid< Implementation, CellIterator >.

## ◆ GetCellData()

vtkCellData* vtkDataSet::GetCellData | ( |  | ) |
| inline

Return a pointer to this dataset's cell data.

THIS METHOD IS THREAD SAFE

Definition at line 298 of file vtkDataSet.h.

## ◆ GetPointData()

vtkPointData* vtkDataSet::GetPointData | ( |  | ) |
| inline

Return a pointer to this dataset's point data.

THIS METHOD IS THREAD SAFE

Definition at line 304 of file vtkDataSet.h.

## ◆ Squeeze()

virtual void vtkDataSet::Squeeze | ( |  | ) |
| virtual

Reclaim any extra memory used to store data.

THIS METHOD IS NOT THREAD SAFE.

Reimplemented in vtkUnstructuredGrid, vtkPolyData, vtkPointSet, and vtkmDataSet.

## ◆ ComputeBounds()

virtual void vtkDataSet::ComputeBounds | ( |  | ) |
| virtual

Compute the data bounding box from data points.

THIS METHOD IS NOT THREAD SAFE.

Reimplemented in vtkRectilinearGrid, vtkPointSet, vtkImageData, and vtkmDataSet.

## ◆ GetBounds() [1/2]

double* vtkDataSet::GetBounds | ( |  | ) |

Return a pointer to the geometry bounding box in the form (xmin,xmax, ymin,ymax, zmin,zmax).

THIS METHOD IS NOT THREAD SAFE.

## ◆ GetBounds() [2/2]

void vtkDataSet::GetBounds | ( | double | bounds[6] | ) |

Return a pointer to the geometry bounding box in the form (xmin,xmax, ymin,ymax, zmin,zmax).

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

## ◆ GetCenter() [1/2]

double* vtkDataSet::GetCenter | ( |  | ) |

Get the center of the bounding box.

THIS METHOD IS NOT THREAD SAFE.

## ◆ GetCenter() [2/2]

void vtkDataSet::GetCenter | ( | double | center[3] | ) |

Get the center of the bounding box.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

## ◆ GetLength()

double vtkDataSet::GetLength | ( |  | ) |

Return the length of the diagonal of the bounding box.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

## ◆ GetLength2()

double vtkDataSet::GetLength2 | ( |  | ) |

Return the squared length of the diagonal of the bounding box.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

## ◆ Initialize()

void vtkDataSet::Initialize | ( |  | ) |
| overridevirtual

Restore data object to initial state.

THIS METHOD IS NOT THREAD SAFE.

Reimplemented from vtkDataObject.

Reimplemented in vtkUnstructuredGrid, vtkUniformGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkPointSet, vtkImageData, and vtkExplicitStructuredGrid.

## ◆ GetScalarRange() [1/2]

virtual void vtkDataSet::GetScalarRange | ( | double | range[2] | ) |
| virtual

Convenience method to get the range of the first component (and only the first component) of any scalars in the data set.

If the data has both point data and cell data, it returns the (min/max) range of combined point and cell data. If there are no point or cell scalars the method will return (0,1). Note: It might be necessary to call Update to create or refresh the scalars before calling this method. THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

## ◆ GetScalarRange() [2/2]

double* vtkDataSet::GetScalarRange | ( |  | ) |

Convenience method to get the range of the first component (and only the first component) of any scalars in the data set.

If the data has both point data and cell data, it returns the (min/max) range of combined point and cell data. If there are no point or cell scalars the method will return (0,1). Note: It might be necessary to call Update to create or refresh the scalars before calling this method. THIS METHOD IS NOT THREAD SAFE.

## ◆ GetMaxCellSize()

virtual int vtkDataSet::GetMaxCellSize | ( |  | ) |
| pure virtual

Convenience method returns largest cell size in dataset.

This is generally used to allocate memory for supporting data structures. THIS METHOD IS THREAD SAFE

Implemented in vtkLabelHierarchy, vtkUnstructuredGrid, vtkUniformGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkPointSet, vtkPath, vtkMappedUnstructuredGrid< Implementation, CellIterator >, vtkImageData, vtkExplicitStructuredGrid, and vtkmDataSet.

## ◆ GetActualMemorySize()

unsigned long vtkDataSet::GetActualMemorySize | ( |  | ) |
| overridevirtual

Return the actual size of the data in kibibytes (1024 bytes).

This number is valid only after the pipeline has updated. The memory size returned is guaranteed to be greater than or equal to the memory required to represent the data (e.g., extra space in arrays, etc. are not included in the return value). THIS METHOD IS THREAD SAFE.

Reimplemented from vtkDataObject.

Reimplemented in vtkUnstructuredGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkPointSet, vtkImageData, and vtkExplicitStructuredGrid.

## ◆ GetDataObjectType()

int vtkDataSet::GetDataObjectType | ( |  | ) |
| inlineoverridevirtual

Return the type of data object.

Reimplemented from vtkDataObject.

Reimplemented in vtkUnstructuredGridBase, vtkUnstructuredGrid, vtkUniformGrid, vtkStructuredPoints, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkPointSet, vtkPath, vtkImageData, and vtkExplicitStructuredGrid.

Definition at line 409 of file vtkDataSet.h.

## ◆ ShallowCopy()

void vtkDataSet::ShallowCopy | ( | vtkDataObject * | src | ) |
| overridevirtual

Shallow and Deep copy.

Reimplemented from vtkDataObject.

Reimplemented in vtkUnstructuredGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkPointSet, vtkMappedUnstructuredGrid< Implementation, CellIterator >, vtkImageData, and vtkExplicitStructuredGrid.

## ◆ DeepCopy()

void vtkDataSet::DeepCopy | ( | vtkDataObject * | src | ) |
| overridevirtual

Shallow and Deep copy.

Reimplemented from vtkDataObject.

Reimplemented in vtkUnstructuredGridBase, vtkUnstructuredGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkPolyData, vtkPointSet, vtkImageData, and vtkExplicitStructuredGrid.

## ◆ CheckAttributes()

int vtkDataSet::CheckAttributes | ( |  | ) |

This method checks to see if the cell and point attributes match the geometry.

Many filters will crash if the number of tuples in an array is less than the number of points/cells. This method returns 1 if there is a mismatch, and 0 if everything is ok. It prints an error if an array is too short, and a warning if an array is too long.

## ◆ GenerateGhostArray() [1/2]

virtual void vtkDataSet::GenerateGhostArray | ( | int | zeroExt[6] | ) |
| inlinevirtual

Normally called by pipeline executives or algorithms only.

This method computes the ghost arrays for a given dataset. The zeroExt argument specifies the extent of the region which ghost type = 0.

Definition at line 442 of file vtkDataSet.h.

## ◆ GenerateGhostArray() [2/2]

virtual void vtkDataSet::GenerateGhostArray | ( | int | zeroExt[6],
|  | bool | cellOnly
| ) |  |
| virtual

Normally called by pipeline executives or algorithms only.

This method computes the ghost arrays for a given dataset. The zeroExt argument specifies the extent of the region which ghost type = 0.

Reimplemented in vtkExplicitStructuredGrid.

## ◆ GetData() [1/2]

static vtkDataSet* vtkDataSet::GetData | ( | vtkInformation * | info | ) |
| static

Retrieve an instance of this class from an information object.

## ◆ GetData() [2/2]

static vtkDataSet* vtkDataSet::GetData | ( | vtkInformationVector * | v,
|  | int | i = `0`
| ) |  |
| static

Retrieve an instance of this class from an information object.

## ◆ GetAttributesAsFieldData()

vtkFieldData* vtkDataSet::GetAttributesAsFieldData | ( | int | type | ) |
| overridevirtual

Returns the attributes of the data object as a vtkFieldData.

This returns non-null values in all the same cases as GetAttributes, in addition to the case of FIELD, which will return the field data for any vtkDataObject subclass.

Reimplemented from vtkDataObject.

## ◆ GetNumberOfElements()

vtkIdType vtkDataSet::GetNumberOfElements | ( | int | type | ) |
| overridevirtual

Get the number of elements for a specific attribute type (POINT, CELL, etc.).

Reimplemented from vtkDataObject.

## ◆ HasAnyGhostCells()

bool vtkDataSet::HasAnyGhostCells | ( |  | ) |

Returns 1 if there are any ghost cells 0 otherwise.

## ◆ HasAnyGhostPoints()

bool vtkDataSet::HasAnyGhostPoints | ( |  | ) |

Returns 1 if there are any ghost points 0 otherwise.

## ◆ HasAnyBlankCells()

virtual bool vtkDataSet::HasAnyBlankCells | ( |  | ) |
| inlinevirtual

Returns 1 if there are any blanking cells 0 otherwise.

Blanking is supported only for vtkStructuredGrid and vtkUniformGrid

Reimplemented in vtkUniformGrid, vtkStructuredGrid, vtkRectilinearGrid, vtkImageData, and vtkExplicitStructuredGrid.

Definition at line 482 of file vtkDataSet.h.

## ◆ HasAnyBlankPoints()

virtual bool vtkDataSet::HasAnyBlankPoints | ( |  | ) |
| inlinevirtual

Returns 1 if there are any blanking points 0 otherwise.

Blanking is supported only for vtkStructuredGrid and vtkUniformGrid

Reimplemented in vtkUniformGrid, vtkStructuredGrid, vtkRectilinearGrid, and vtkImageData.

Definition at line 488 of file vtkDataSet.h.

## ◆ GetPointGhostArray()

vtkUnsignedCharArray* vtkDataSet::GetPointGhostArray | ( |  | ) |

Gets the array that defines the ghost type of each point.

We cache the pointer to the array to save a lookup involving string comparisons

## ◆ UpdatePointGhostArrayCache()

void vtkDataSet::UpdatePointGhostArrayCache | ( |  | ) |
| inline

Updates the pointer to the point ghost array.

Definition at line 500 of file vtkDataSet.h.

## ◆ AllocatePointGhostArray()

vtkUnsignedCharArray* vtkDataSet::AllocatePointGhostArray | ( |  | ) |

Allocate ghost array for points.

## ◆ GetCellGhostArray()

vtkUnsignedCharArray* vtkDataSet::GetCellGhostArray | ( |  | ) |

Get the array that defines the ghost type of each cell.

We cache the pointer to the array to save a lookup involving string comparisons

## ◆ UpdateCellGhostArrayCache()

void vtkDataSet::UpdateCellGhostArrayCache | ( |  | ) |
| inline

Updates the pointer to the cell ghost array.

Definition at line 517 of file vtkDataSet.h.

## ◆ AllocateCellGhostArray()

vtkUnsignedCharArray* vtkDataSet::AllocateCellGhostArray | ( |  | ) |

Allocate ghost array for cells.

## ◆ GetGhostArray()

vtkUnsignedCharArray* vtkDataSet::GetGhostArray | ( | int | type | ) |
| overridevirtual

Returns the ghost array for the given type (point or cell).

Takes advantage of the cache with the pointer to the array to save a string comparison.

Reimplemented from vtkDataObject.

## ◆ ComputeScalarRange()

virtual void vtkDataSet::ComputeScalarRange | ( |  | ) |
| protectedvirtual

Compute the range of the scalars and cache it into ScalarRange only if the cache became invalid (ScalarRangeComputeTime).

Reimplemented in vtkUniformGrid, vtkStructuredGrid, and vtkExplicitStructuredGrid.

## Member Data Documentation

## ◆ CellData

vtkCellData* vtkDataSet::CellData
| protected

Definition at line 541 of file vtkDataSet.h.

## ◆ PointData

vtkPointData* vtkDataSet::PointData
| protected

Definition at line 542 of file vtkDataSet.h.

## ◆ DataObserver

vtkCallbackCommand* vtkDataSet::DataObserver
| protected

Definition at line 543 of file vtkDataSet.h.

## ◆ ComputeTime

vtkTimeStamp vtkDataSet::ComputeTime
| protected

Definition at line 544 of file vtkDataSet.h.

## ◆ Bounds

double vtkDataSet::Bounds[6]
| protected

Definition at line 545 of file vtkDataSet.h.

## ◆ Center

double vtkDataSet::Center[3]
| protected

Definition at line 546 of file vtkDataSet.h.

## ◆ ScalarRange

double vtkDataSet::ScalarRange[2]
| protected

Definition at line 549 of file vtkDataSet.h.

## ◆ ScalarRangeComputeTime

vtkTimeStamp vtkDataSet::ScalarRangeComputeTime
| protected

Definition at line 552 of file vtkDataSet.h.

## ◆ PointGhostArray

vtkUnsignedCharArray* vtkDataSet::PointGhostArray
| protected

These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name))

Definition at line 560 of file vtkDataSet.h.

## ◆ CellGhostArray

vtkUnsignedCharArray* vtkDataSet::CellGhostArray
| protected

These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name))

Definition at line 562 of file vtkDataSet.h.

## ◆ PointGhostArrayCached

bool vtkDataSet::PointGhostArrayCached
| protected

These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name))

Definition at line 564 of file vtkDataSet.h.

## ◆ CellGhostArrayCached

bool vtkDataSet::CellGhostArrayCached
| protected

These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name))

Definition at line 566 of file vtkDataSet.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkDataSet.h